<!-- Component to display all countries grouped by region -->
<template>
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <h1><img :src="all.flag" :alt="all.name" height="28px" class="mr-2">{{ all.name }}</h1>
            </div>
        </div>
        <div class="row">
            <div class="col-md-10">
                <div class="card">
                    <div class="card-header d-flex">
                        <h4 class="card-title flex-grow-1">General Details</h4>
                        <router-link to="/" tag="button" class="btn btn-primary btn-sm ">Back Home</router-link>
                    </div>
                    <div class="card-body d-flex">
                        <ul class="list-unstyled flex-fill">
                            <li><b>Region</b> : {{ all.region }}</li>
                            <li><b>Sun region</b> : {{ all.subregion }}</li>
                            <li><b>Native name</b> : {{ all.nativeName }}</li>
                            <li><b>Capital</b> : {{ all.capital }}</li>
                            <li><b>Demonym</b> : {{ all.demonym }}</li>
                            <li><b>Currencies</b>:                            
                                <span class="text-capitalized" v-for=" (currency,count) in all.currencies"  :key="count">{{ currency.name }}</span>                               
                            </li>
                            <li><b>Langauges</b>:
                                <ul class="list-unstyled ml-2"> 
                                    <li v-for=" (lang,cnt) in all.languages" :key="cnt">
                                        <span class="text-capitalized" >{{ lang.name }}</span>
                                    </li>
                                </ul>
                            </li>                            
                            <li><b>Alpha2 code</b> : {{ all.alpha2Code }}</li>
                            <li><b>Alpha3 code</b> : {{ all.alpha3Code }}</li>
                            <li><b>Calling codes</b> : {{ all.callingCodes.join() }}</li>                            
                        </ul>
                        <ul class="list-unstyled flex-fill">
                            <li><b>Regional Blocs : </b>
                                <span class="text-capitalized" v-for="(region,x) in all.regionalBlocs" :key="x">{{ region.name }}</span>
                            </li>
                            <li><b>Population</b> : {{ all.population }}</li>
                            <li><b>Top Level Domain</b> : {{ all.topLevelDomain.join(",") }}</li>
                            <li><b>Latlng</b> : {{ all.latlng.join() }}  </li>
                            <li><b>Timezone</b> : {{ all.timezones.join(", ") }}</li>
                            <li><b>borders</b> : {{ all.borders.join(", ") }}</li>
                            <li><b>Numeric code</b> : {{ all.numericCode }}</li>
                            <li><b>Area</b> : {{ all.area }}</li>
                            
                        </ul>
                    </div>
                </div>
            </div>
           
        </div>
    </div>
</template>

<script>
    import { mapActions,mapGetters } from "vuex"
    import Search from '@/components/search_country.vue'

    export default {
        name: "country_details",
        data() {
            return {
                url_param: ''
            }
        },
        components: {
            Search
        },
        computed: {
            ...mapGetters({
                all: 'details',
            })
        },
        methods: {
            ...mapActions({
                getDetails: 'fetchDetails'
            }),
            displayAll: function(load) {
                let str = ''
                let count = load.length
                load.forEach( (el,i) => {
                    if(i < count) {
                        str = str + el + ','
                    }
                });

                return str
            },
        },
        mounted() { 
            const alphacode = this.$route.params.code
            this.url_param = alphacode
            this.getDetails(alphacode.toLowerCase())
        }
    }
</script>

<style scoped>

</style>